#include "datafox/communication/controller_segment.h"

ControllerSegment::ControllerSegment()
{
    init();
}

void ControllerSegment::init()
{
    reset();
    transferFlags.settingsFromGlobal = false;
    allowedTransferTypes = 0;
    duration = std::chrono::seconds(0);
}

void ControllerSegment::reset()
{
    transferState = BlockTransferState::inactive;
    transferType = btt_none;
    beginTimePoint = std::chrono::system_clock::time_point();
    currentTimeSlotTimePoint = std::chrono::system_clock::time_point();;
    endTimePoint = std::chrono::system_clock::time_point();;
    updateVariation = 0;
    number = 0;
    maxNumber = 0;
    address = 0;
    size = 0;
    crc = 0;
    resume = false;
    discard = false;
}