#include "file/interface/dfitem/dfitem_handling.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDFItemHandling::CDFItemHandling( tinyxml2::XMLDocument *doc ) : CDFItemBase( doc )
{
    xmlElement()->SetText( "ItemHandling" );
}

CDFItemHandling::~CDFItemHandling()
{

}

int CDFItemHandling::Modify( CModifyData &modifyData )
{
    int i;
    unsigned int offs = modifyData.offsFlash, offsChild;
    StructOperating bedien;
    CDFItemBase *item = nullptr;

    // Daten von Konfig Root einlesen
    StructConfigRoot &root = *(StructConfigRoot *)&modifyData.file->m_flash[modifyData.offsFlash - FLASH_KONFIG_START];
    ChangeOrderLong( (unsigned char *)&root.ptr );
    offs += sizeof( StructConfigRoot );

    // Daten aller Eintraege einlesen
    for ( i = 0; i < (int)root.numberOfEntries; ++i )
    {
        // Pointer des Eintrags berechnen
        offsChild = root.ptr + i * sizeof( unsigned int );

        offsChild = *(unsigned int *)&modifyData.file->m_flash[offsChild - FLASH_KONFIG_START];
        ChangeOrderLong( (unsigned char *)&offsChild );

        // Daten von Bedien - Struktur fuer Klassenerzeugung einlesen
        bedien = *(StructOperating *)&modifyData.file->m_flash[offsChild - FLASH_KONFIG_START];

        switch ( bedien.type )
        {
            case TB_MENUE:
            {
                item = new CDFItemMenu( xmlElement()->GetDocument() );
                break;
            }

            case TB_DATENSATZ:
            {
                item = new CDFItemInputChain( xmlElement()->GetDocument() );
                break;
            }

            default:
                break;
        }

        xmlElement()->InsertEndChild( item->xmlElement() );
        modifyData.offsFlash = offsChild;
        item->Modify( modifyData );
    }

    // Adresse zurueckkonvertieren
    ChangeOrderLong( (unsigned char *)&root.ptr );

    return 1;
}
